\set{capture}{hidden}
\begin{code}

module C.Syntax (
	S, D, B, L, V, C, J, I,
	DesignatorT (..),
	LinkageT (..),
	TypeT (..),
	IntegerSpecifierT (..),
	PrototypeT (..),
	TypesT,
	MemberT (..),	
	MembersT,
	FloatingConstantT (..),
	IntegerConstantT (..),
	CharacterConstantT (..),
	EnumerationConstantT,
	StringLiteralT (..),
	ConstantT (..),
	PrimaryExpressionT (..),
	PostfixExpressionT (..),
	ArgumentExpressionListT (..),
	UnaryExpressionT (..),
	UnaryOperatorT (..),
	CastExpressionT (..),
	MultiplicativeExpressionT (..),
	AdditiveExpressionT (..),
	ShiftExpressionT (..),
	RelationalExpressionT (..),
	EqualityExpressionT (..),
	AndExpressionT (..),
	ExclusiveOrExpressionT (..),
	InclusiveOrExpressionT (..),
	LogicalAndExpressionT (..),
	LogicalOrExpressionT (..),
	ConditionalExpressionT (..),
	AssignmentExpressionT (..),
	AssignmentOperatorT (..),
	ExpressionT (..),
	ConstantExpressionT,
	DeclarationT (..),
	DeclarationSpecifiersT (..),
	InitDeclaratorListT (..),
	InitDeclaratorT (..),
	StorageClassSpecifierT (..),
	TypeSpecifierT (..),
	StructOrUnionSpecifierT (..),
	StructOrUnionT (..),
	StructDeclarationListT (..),
	StructDeclarationT (..),
	SpecifierQualifierListT (..),
	StructDeclaratorListT (..),
	StructDeclaratorT (..),
	EnumSpecifierT (..),
	EnumeratorListT (..),
	EnumeratorT (..),
	TypeQualifierT (..),
	DeclaratorT (..),
	DirectDeclaratorT (..),
	PointerT (..),
	TypeQualifierListT (..),
	ParameterTypeListT (..),
	ParameterListT (..),
	ParameterDeclarationT (..),
	IdentifierListT (..),
	TypeNameT (..),
	AbstractDeclaratorT (..),
	DirectAbstractDeclaratorT (..),
	TypedefNameT,
	InitialiserT (..),
	InitialiserListT (..),
	StatementT (..),
	LabelledStatementT (..),
	CompoundStatementT (..),
	DeclarationListT (..),
	StatementListT (..),
	ExpressionStatementT (..),
	SelectionStatementT (..),
	IterationStatementT (..),
	JumpStatementT (..),
	TranslationUnitT (..),
	ExternalDeclarationT (..),
	FunctionDefinitionT (..),
) where

import Additional
import C.Variables
import Lambda

\end{code}
\begin{syntax}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{S}					{Ord}	{«S»}
\NewHaskellResult	{S}						{Type}

\set{capture}		{S}
\begin{code}
type S			= MapT (IdentifierT)	(DesignatorT)		-- current variable or tag scope
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{D}					{Ord}	{«D»}
\NewHaskellResult	{D}						{Type}

\set{capture}		{D}
\begin{code}
type D			= MapT (VarT)		(Maybe (ItemT VarT))	-- variable definitions
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{B}					{Ord}	{«B»}
\NewHaskellResult	{B}						{Type}

\set{capture}		{B}
\begin{code}
type B			= MapT (VarT)		(V)			-- basic block definitions
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{L}					{Ord}	{«L»}
\NewHaskellResult	{L}						{Type}

\set{capture}		{L}
\begin{code}
type L			= MapT (IdentifierT)	(VarT)			-- label definitions
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{V}					{Ord}	{«V»}
\NewHaskellResult	{V}						{Type}

\set{capture}		{V}
\begin{code}
type V			= MapT (VarT)		(EnvelopeT)		-- local variable definitions
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{C}					{Ord}	{«C»}
\NewHaskellResult	{C}						{Type}

\set{capture}		{C}
\begin{code}
type C			= MapT (Maybe Integer)	(VarT)			-- case label definitions
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{J}					{Ord}	{«J»}
\NewHaskellResult	{J}						{Type}

\set{capture}		{J}
\begin{code}
type J			= SetT (IdentifierT)				-- required label variables
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{I}					{Ord}	{«I»}
\NewHaskellResult	{I}						{Type}

\set{capture}		{I}
\begin{code}
type I			= Integer					-- scope index
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DesignatorT}				{Ord}	{«designator»}
\NewHaskellResult	{DesignatorT}					{Type}
\NewVariable		{designator}

\BeginHaskellToken	{Designator}				{Void}	{}
  \HaskellArgument							{LinkageT}
  \HaskellArgument							{TypeT}
  \HaskellToken		{{-@-}}					{Ord}	{\CSyntax{@}}
  \HaskellArgument							{I}
  \HaskellResult							{DesignatorT}
\EndHaskellToken

\set{capture}		{DesignatorT}
\begin{code}
data DesignatorT =
	Designator (LinkageT) (TypeT) {-@-} (I) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{LinkageT}				{Ord}	{«linkage»}
\NewHaskellResult	{LinkageT}					{Type}
\NewVariable		{linkage}

\BeginHaskellToken	{ExternLinkage}				{Ord}	{\CSyntax{extern}}
  \HaskellArgument							{VarT}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\BeginHaskellToken	{InternLinkage}				{Ord}	{\CSyntax{intern}}
  \HaskellArgument							{VarT}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\BeginHaskellToken	{PrivateLinkage}			{Ord}	{\CSyntax{private}}
  \HaskellArgument							{VarT}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\BeginHaskellToken	{AutoLinkage}				{Ord}	{\CSyntax{auto}}
  \HaskellArgument							{VarT}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\BeginHaskellToken	{RegisterLinkage}			{Ord}	{\CSyntax{register}}
  \HaskellArgument							{VarT}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\BeginHaskellToken	{ConstantLinkage}			{Ord}	{\CSyntax{const}}
  \HaskellArgument							{Integer}
  \HaskellResult							{LinkageT}
\EndHaskellToken

\NewHaskellToken	{TypeLinkage}				{Ord}	{\CSyntax{type}}
\NewHaskellResult	{TypeLinkage}					{LinkageT}

\set{capture}		{LinkageT}
\begin{code}
data LinkageT =
	ExternLinkage (VarT)					-- external linkage
	| InternLinkage (VarT)					-- internal linkage
	| PrivateLinkage (VarT)					-- private linkage
	| AutoLinkage (VarT)					-- automatic linkage
	| RegisterLinkage (VarT)				-- register linkage
	| ConstantLinkage (Integer)				-- constant linkage
	| TypeLinkage deriving (Eq, Ord, Show)			-- type linkage
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypeT}					{Ord}	{«type»}
\NewHaskellResult	{TypeT}						{Type}
\NewVariable		{type}

\BeginHaskellToken	{Signed}				{Ord}	{\CSyntax{signed}}
  \HaskellArgument							{IntegerSpecifierT}
  \HaskellResult							{TypeT}
\EndHaskellToken

\BeginHaskellToken	{Unsigned}				{Ord}	{\CSyntax{unsigned}}
  \HaskellArgument							{IntegerSpecifierT}
  \HaskellResult							{TypeT}
\EndHaskellToken

\NewHaskellToken	{PlainCharType}				{Ord}	{\CSyntax{char}}
\NewHaskellResult	{PlainCharType}					{TypeT}
\NewHaskellToken	{PlainIntType}				{Ord}	{\CSyntax{int}}
\NewHaskellResult	{PlainIntType}					{TypeT}

\BeginHaskellToken	{EnumType}				{Ord}	{\CSyntax{enum}}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{VarT}
  \HaskellResult							{TypeT}
\EndHaskellToken

\NewHaskellToken	{FloatType}				{Ord}	{\CSyntax{float}}
\NewHaskellResult	{FloatType}					{TypeT}
\NewHaskellToken	{DoubleType}				{Ord}	{\CSyntax{double}}
\NewHaskellResult	{DoubleType}					{TypeT}
\NewHaskellToken	{LongDoubleType}			{Ord}	{\CSyntax{long} \CSyntax{double}}
\NewHaskellResult	{LongDoubleType}				{TypeT}

\BeginHaskellToken	{PointerType}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellToken		{{-*-}}					{Close}	{\WhiteSpace\CSyntax{*}}
  \HaskellResult							{TypeT}
\EndHaskellToken

\BeginHaskellToken	{CompoundType}				{Void}	{}
  \HaskellArgument							{StructOrUnionT}
  \HaskellArgument							{VarT}
  \HaskellArgument							{MembersT}
  \HaskellResult							{TypeT}
\EndHaskellToken

\BeginHaskellToken	{ArrayType}				{Void}	{}
  \HaskellArgument							{TypeT}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CSyntax{\[}\WhiteSpace}
    \RawHaskellArgument							{Maybe Integer}
  \EndHaskellParens						{Close}	{\WhiteSpace\CSyntax{\]}}
  \HaskellResult							{TypeT}
\EndHaskellToken

\BeginHaskellToken	{`ArrayType`}				{Op}	{\!}
  \BeginHaskellParens						{Open}	{\WhiteSpace\CSyntax{\[}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CSyntax{\]}}
\EndHaskellToken

\BeginHaskellToken	{FunctionType}				{Void}	{}
  \HaskellArgument							{TypeT}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CSyntax{(}\WhiteSpace}
    \RawHaskellArgument							{Maybe PrototypeT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CSyntax{)}}
  \HaskellResult							{TypeT}
\EndHaskellToken

\BeginHaskellToken	{`FunctionType`}			{Op}	{\!}
  \BeginHaskellParens						{Open}	{\WhiteSpace\CSyntax{(}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CSyntax{)}}
\EndHaskellToken

\BeginHaskellToken	{BitFieldType}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellToken		{{-:-}}					{Op}	{\WhiteSpace\CSyntax{:}\WhiteSpace}
  \HaskellArgument							{Integer}
  \HaskellToken		{{-@-}}					{Op}	{\WhiteSpace\CSyntax{.}\WhiteSpace}
  \HaskellArgument							{Integer}
  \HaskellResult							{TypeT}
\EndHaskellToken

\NewHaskellToken	{VoidType}				{Ord}	{\CSyntax{void}}
\NewHaskellResult	{VoidType}					{TypeT}

\BeginHaskellToken	{Qualified}				{Void}	{}
  \HaskellArgument							{TypeQualifierT}
  \HaskellArgument							{TypeT}
  \HaskellResult							{TypeT}
\EndHaskellToken

\set{capture}		{TypeT}
\begin{code}
data TypeT =
	Signed (IntegerSpecifierT)						-- signed integer types
	| Unsigned (IntegerSpecifierT)						-- unsigned integer types
	| PlainCharType								-- plain character type
	| PlainIntType								-- plain integer type
	| EnumType (TypeT) (VarT)						-- enumeration types
	| FloatType								-- single precision floating type
	| DoubleType								-- double precision floating type
	| LongDoubleType							-- extended floating point type
	| CompoundType (StructOrUnionT) (VarT) (MembersT)			-- structure and union types
	| PointerType (TypeT) {-*-}						-- pointer types
	| ArrayType (TypeT) (Maybe Integer)					-- array types
	| FunctionType (TypeT) (Maybe PrototypeT)				-- function types
	| BitFieldType (TypeT) {-:-} (Integer) {-@-} (Integer)			-- bit field types
	| VoidType								-- the void type
	| Qualified (TypeQualifierT) (TypeT) deriving (Eq, Ord, Show)		-- variable types
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{IntegerSpecifierT}			{Ord}	{«integer-specifier»}
\NewHaskellResult	{IntegerSpecifierT}				{Type}
\NewVariable		{integer_specifier}

\NewHaskellToken	{CharType}				{Ord}	{\CSyntax{char}}
\NewHaskellResult	{CharType}					{IntegerSpecifierT}
\NewHaskellToken	{ShortType}				{Ord}	{\CSyntax{short}}
\NewHaskellResult	{ShortType}					{IntegerSpecifierT}
\NewHaskellToken	{IntType}				{Ord}	{\CSyntax{int}}
\NewHaskellResult	{IntType}					{IntegerSpecifierT}
\NewHaskellToken	{LongType}				{Ord}	{\CSyntax{long}}
\NewHaskellResult	{LongType}					{IntegerSpecifierT}

\set{capture}		{IntegerSpecifierT}
\begin{code}
data IntegerSpecifierT {-one-of-} =
	CharType {-alt-}| --
	ShortType {-alt-}| --
	IntType {-alt-}| --
	LongType deriving (Eq, Ord, Show)					-- integral type variants
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{PrototypeT}				{Ord}	{«prototype»}
\NewHaskellResult	{PrototypeT}					{Type}
\NewVariable		{prototype}

\BeginHaskellToken	{Types}					{Void}	{}
  \HaskellArgument							{TypesT}
  \HaskellResult							{PrototypeT}
\EndHaskellToken

\BeginHaskellToken	{Ellipsis}				{Void}	{}
  \HaskellArgument							{TypesT}
  \HaskellToken		{{-...-}}				{Close}	{\WhiteSpace\CSyntax{.\!\!.\!\!.}}
  \HaskellResult							{PrototypeT}
\EndHaskellToken

\NewHaskellToken	{{-...-}}				{Ord}	{\CSyntax{.\!\!.\!\!.}}

\set{capture}		{PrototypeT}
\begin{code}
data PrototypeT =
	Types (TypesT)
	| Ellipsis (TypesT) {-...-} deriving (Eq, Ord, Show)			-- function prototypes
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypesT}				{Ord}	{«types»}
\NewHaskellResult	{TypesT}					{Type}
\NewVariable		{types}

\set{capture}		{TypesT}
\begin{code}
type TypesT =
	[TypeT]									-- a list of types
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{MemberT}				{Ord}	{«member»}
\NewHaskellResult	{MemberT}					{Type}
\NewVariable		{member}

\BeginHaskellToken	{Member}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{Maybe IdentifierT}
  \HaskellToken		{{-@-}}					{Ord}	{\CSyntax{@}}
  \HaskellArgument							{Integer}
  \HaskellResult							{MemberT}
\EndHaskellToken

\set{capture}		{MemberT}
\begin{code}	
data MemberT =
	Member (TypeT) (Maybe IdentifierT) {-@-} (Integer) --
	deriving (Eq, Ord, Show)						-- structure and union members
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{MembersT}				{Ord}	{«members»}
\NewHaskellResult	{MembersT}					{Type}
\NewVariable		{members}

\set{capture}		{MembersT}
\begin{code}
type MembersT =
	[MemberT]								-- member lists
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{FloatingConstantT}			{Ord}	{«floating-constant»}
\NewHaskellResult	{FloatingConstantT}				{Type}
\NewVariable		{floating_constant}

\BeginHaskellToken	{FloatingValue}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{Rational}
  \HaskellResult							{FloatingConstantT}
\EndHaskellToken

\set{capture}		{FloatingConstantT}
\begin{code}
data FloatingConstantT =
	 FloatingValue (TypeT) (Rational) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{IntegerConstantT}			{Ord}	{«integer-constant»}
\NewHaskellResult	{IntegerConstantT}				{Type}
\NewVariable		{integer_constant}

\BeginHaskellToken	{IntegerValue}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{Integer}
  \HaskellResult							{IntegerConstantT}
\EndHaskellToken

\set{capture}		{IntegerConstantT}
\begin{code}
data IntegerConstantT =
	IntegerValue (TypeT) (Integer) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{CharacterConstantT}			{Ord}	{«character-constant»}
\NewHaskellResult	{CharacterConstantT}				{Type}
\NewVariable		{character_constant}

\BeginHaskellToken	{CharacterValue}			{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{Integer}
  \HaskellResult							{CharacterConstantT}
\EndHaskellToken

\set{capture}		{CharacterConstantT}
\begin{code}
data CharacterConstantT =
	CharacterValue TypeT Integer deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{EnumerationConstantT}			{Ord}	{«enumeration-constant»}
\NewHaskellResult	{EnumerationConstantT}				{Type}
\NewVariable		{enumeration_constant}

\BeginHaskellToken	{EnumerationConstantT'}			{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{EnumerationConstantT}
\EndHaskellToken

\set{capture}		{EnumerationConstantT}
\begin{code}
type EnumerationConstantT =
	IdentifierT
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StringLiteralT}			{Ord}	{«string-literal»}
\NewHaskellResult	{StringLiteralT}				{Type}
\NewVariable		{string_literal}

\BeginHaskellToken	{StringValue}				{Void}	{}
  \HaskellArgument							{TypeT}
  \HaskellArgument							{DataT VarT}
  \HaskellResult							{StringLiteralT}
\EndHaskellToken

\set{capture}		{StringLiteralT}
\begin{code}
data StringLiteralT =
	StringValue (TypeT) (DataT VarT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ConstantT}				{Ord}	{«constant»}
\NewHaskellResult	{ConstantT}					{Type}
\NewVariable		{constant}

\BeginHaskellToken	{FloatingConstant}			{Void}	{}
  \HaskellArgument							{FloatingConstantT}
  \HaskellResult							{ConstantT}
\EndHaskellToken

\BeginHaskellToken	{IntegerConstant}			{Void}	{}
  \HaskellArgument							{IntegerConstantT}
  \HaskellResult							{ConstantT}
\EndHaskellToken

\BeginHaskellToken	{EnumerationConstant}			{Void}	{}
  \HaskellArgument							{EnumerationConstantT}
  \HaskellResult							{ConstantT}
\EndHaskellToken

\BeginHaskellToken	{CharacterConstant}			{Void}	{}
  \HaskellArgument							{CharacterConstantT}
  \HaskellResult							{ConstantT}
\EndHaskellToken

\set{capture}		{ConstantT}
\begin{code}
data ConstantT =
	FloatingConstant (FloatingConstantT)
	| IntegerConstant (IntegerConstantT)
	| EnumerationConstant (EnumerationConstantT)
	| CharacterConstant (CharacterConstantT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{PrimaryExpressionT}			{Ord}	{«primary-expression»}
\NewHaskellResult	{PrimaryExpressionT}				{Type}
\NewVariable		{primary_expression}

\BeginHaskellToken	{Variable}				{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{PrimaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Constant}				{Void}	{}
  \HaskellArgument							{ConstantT}
  \HaskellResult							{PrimaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{StringLiteral}				{Void}	{}
  \HaskellArgument							{StringLiteralT}
  \HaskellResult							{PrimaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{NestedExpression}			{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{PrimaryExpressionT}
\EndHaskellToken

\set{capture}		{PrimaryExpressionT}
\begin{code}
data PrimaryExpressionT =
	Variable (IdentifierT)
	| Constant (ConstantT)
	| StringLiteral (StringLiteralT)
	| NestedExpression (ExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{PostfixExpressionT}			{Ord}	{«postfix-expression»}
\NewHaskellResult	{PostfixExpressionT}				{Type}
\NewVariable		{postfix_expression}

\BeginHaskellToken	{E16}					{Void}	{}
  \HaskellArgument							{PrimaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{ArraySubscript}			{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CKeyword{\[}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\BeginHaskellToken	{`ArraySubscript`}			{Void}	{}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CKeyword{\[}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
\EndHaskellToken

\BeginHaskellToken	{FunctionCall}				{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{Maybe ArgumentExpressionListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\BeginHaskellToken	{`FunctionCall`}			{Void}	{}
  \BeginHaskellParens						{Op}	{\WhiteSpace\CKeyword{(}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
\EndHaskellToken

\BeginHaskellToken	{DirectMember}				{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \HaskellToken		{{-.-}}					{Op}	{\WhiteSpace\CKeyword{.}\WhiteSpace}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\NewHaskellToken	{`DirectMember`}			{Op}	{\WhiteSpace\CKeyword{.}\WhiteSpace}

\BeginHaskellToken	{IndirectMember}			{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \HaskellToken		{{-->-}}				{Op}	{\WhiteSpace\CKeyword{->}\WhiteSpace}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\NewHaskellToken	{`IndirectMember`}			{Op}	{\WhiteSpace\CKeyword{->}\WhiteSpace}

\BeginHaskellToken	{PostIncrement}				{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \HaskellToken		{{-++-}}				{Close}	{\WhiteSpace\CKeyword{++}}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\BeginHaskellToken	{PostDecrement}				{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \HaskellToken		{{----}}				{Close}	{\WhiteSpace\CKeyword{-{}-}}
  \HaskellResult							{PostfixExpressionT}
\EndHaskellToken

\set{capture}		{PostfixExpressionT}
\begin{code}
data PostfixExpressionT =
	E16 (PrimaryExpressionT)
	| ArraySubscript (PostfixExpressionT) 	(ExpressionT)
	| FunctionCall (PostfixExpressionT) 	(Maybe ArgumentExpressionListT)
	| DirectMember (PostfixExpressionT) 	{-.-}	(IdentifierT)
	| IndirectMember (PostfixExpressionT) 	{-->-}	(IdentifierT)
	| PostIncrement (PostfixExpressionT)	{-++-}
	| PostDecrement (PostfixExpressionT)	{----} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ArgumentExpressionListT}		{Ord}	{«argument-expression-list»}
\NewHaskellResult	{ArgumentExpressionListT}			{Type}
\NewVariable		{argument_expression_list}

\BeginHaskellToken	{E0}					{Void}	{}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{ArgumentExpressionListT}
\EndHaskellToken

\BeginHaskellToken	{En}					{Void}	{}
  \HaskellArgument							{ArgumentExpressionListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{ArgumentExpressionListT}
\EndHaskellToken

\NewHaskellToken	{`En`}					{Close}	{\WhiteSpace\CKeyword{,\!}}

\set{capture}		{ArgumentExpressionListT}
\begin{code}
data ArgumentExpressionListT =
	E0 (AssignmentExpressionT)
	| En (ArgumentExpressionListT) (AssignmentExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{UnaryExpressionT}			{Ord}	{«unary-expression»}
\NewHaskellResult	{UnaryExpressionT}				{Type}
\NewVariable		{unary_expression}

\BeginHaskellToken	{E15}					{Void}	{}
  \HaskellArgument							{PostfixExpressionT}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Increment}				{Open}	{\CKeyword{++}\WhiteSpace}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Decrement}				{Open}	{\CKeyword{-{}-}\WhiteSpace}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Unary}					{Void}	{}
  \HaskellArgument							{UnaryOperatorT}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{SizeOf}				{Ord}	{\CKeyword{sizeof}}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\BeginHaskellToken	{SizeOfType}				{Ord}	{\CKeyword{sizeof}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{TypeNameT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{UnaryExpressionT}
\EndHaskellToken

\set{capture}		{UnaryExpressionT}
\begin{code}
data UnaryExpressionT =
	E15 (PostfixExpressionT)
	| Increment (UnaryExpressionT)
	| Decrement (UnaryExpressionT)
	| Unary (UnaryOperatorT) (CastExpressionT)
	| SizeOf (UnaryExpressionT)
	| SizeOfType (TypeNameT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{UnaryOperatorT}			{Ord}	{«unary-operator»}
\NewHaskellResult	{UnaryOperatorT}				{Type}
\NewVariable		{unary_operator}

\NewHaskellToken	{Address}				{Open}	{\CKeyword{\&}\WhiteSpace}
\NewHaskellResult	{Address}					{UnaryOperatorT}
\NewHaskellToken	{Indirection}				{Open}	{\CKeyword{*}\WhiteSpace}
\NewHaskellResult	{Indirection}					{UnaryOperatorT}
\NewHaskellToken	{Plus}					{Open}	{\CKeyword{+}\WhiteSpace}
\NewHaskellResult	{Plus}						{UnaryOperatorT}
\NewHaskellToken	{Minus}					{Open}	{\CKeyword{-}\WhiteSpace}
\NewHaskellResult	{Minus}						{UnaryOperatorT}
\NewHaskellToken	{Not}					{Open}	{\CKeyword{\~}\WhiteSpace}
\NewHaskellResult	{Not}						{UnaryOperatorT}
\NewHaskellToken	{LogicalNot}				{Open}	{\CKeyword{!}\WhiteSpace}
\NewHaskellResult	{LogicalNot}					{UnaryOperatorT}

\set{capture}		{UnaryOperatorT}
\begin{code}
data UnaryOperatorT {-one-of-} =
	Address {-alt-}| Indirection {-alt-}| Plus {-alt-}| Minus {-alt-}| Not {-alt-}| LogicalNot deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{CastExpressionT}			{Ord}	{«cast-expression»}
\NewHaskellResult	{CastExpressionT}				{Type}
\NewVariable		{cast_expression}

\BeginHaskellToken	{E14}					{Void}	{}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellResult							{CastExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Cast}					{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{TypeNameT}
  \EndHaskellParens						{Op}	{\WhiteSpace\CKeyword{)}\WhiteSpace}
  \HaskellArgument							{CastExpressionT}
  \HaskellResult							{CastExpressionT}
\EndHaskellToken

\set{capture}		{CastExpressionT}
\begin{code}
data CastExpressionT =
	E14 (UnaryExpressionT)
	| Cast (TypeNameT) (CastExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{MultiplicativeExpressionT}		{Ord}	{«multiplicative-expression»}
\NewHaskellResult	{MultiplicativeExpressionT}			{Type}
\NewVariable		{multiplicative_expression}

\BeginHaskellToken	{E13}					{Void}	{}
  \HaskellArgument							{CastExpressionT}
  \HaskellResult							{MultiplicativeExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Product}				{Void}	{}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellToken		{{-*-}}					{Ord}	{\CKeyword{*}}
  \HaskellArgument							{CastExpressionT}
  \HaskellResult							{MultiplicativeExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Quotient}				{Void}	{}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellToken		{{-/-}}					{Ord}	{\CKeyword{/}}
  \HaskellArgument							{CastExpressionT}
  \HaskellResult							{MultiplicativeExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Remainder}				{Void}	{}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellToken		{{-\%-}}				{Ord}	{\CKeyword{\%}}
  \HaskellArgument							{CastExpressionT}
  \HaskellResult							{MultiplicativeExpressionT}
\EndHaskellToken

\NewHaskellToken	{`Product`}				{Ord}	{\CKeyword{*}}
\NewHaskellToken	{`Quotient`}				{Ord}	{\CKeyword{/}}
\NewHaskellToken	{`Remainder`}				{Ord}	{\CKeyword{\%}}

\set{capture}		{MultiplicativeExpressionT}
\begin{code}
data MultiplicativeExpressionT =
	E13 (CastExpressionT)
	| Product   (MultiplicativeExpressionT) {-*-} (CastExpressionT)
	| Quotient  (MultiplicativeExpressionT) {-/-} (CastExpressionT)
	| Remainder (MultiplicativeExpressionT) {-%-} (CastExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{AdditiveExpressionT}			{Ord}	{«additive-expression»}
\NewHaskellResult	{AdditiveExpressionT}				{Type}
\NewVariable		{additive_expression}

\BeginHaskellToken	{E12}					{Void}	{}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellResult							{AdditiveExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Sum}					{Void}	{}
  \HaskellArgument							{AdditiveExpressionT}
  \HaskellToken		{{-+-}}					{Ord}	{\CKeyword{+}}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellResult							{AdditiveExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Difference}				{Void}	{}
  \HaskellArgument							{AdditiveExpressionT}
  \HaskellToken		{{---}}					{Ord}	{\CKeyword{-}}
  \HaskellArgument							{MultiplicativeExpressionT}
  \HaskellResult							{AdditiveExpressionT}
\EndHaskellToken

\NewHaskellToken	{`Sum`}					{Ord}	{\CKeyword{+}}
\NewHaskellToken	{`Difference`}				{Ord}	{\CKeyword{-}}

\set{capture}		{AdditiveExpressionT}
\begin{code}
data AdditiveExpressionT =
	E12 (MultiplicativeExpressionT)
	| Sum        (AdditiveExpressionT) {-+-} (MultiplicativeExpressionT)
	| Difference (AdditiveExpressionT) {---} (MultiplicativeExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ShiftExpressionT}			{Ord}	{«shift-expression»}
\NewHaskellResult	{ShiftExpressionT}				{Type}
\NewVariable		{shift_expression}

\BeginHaskellToken	{E11}					{Void}	{}
  \HaskellArgument							{AdditiveExpressionT}
  \HaskellResult							{ShiftExpressionT}
\EndHaskellToken

\BeginHaskellToken	{LeftShift}				{Void}	{}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellToken		{{-<<-}}				{Ord}	{\CKeyword{<{}<}}
  \HaskellArgument							{AdditiveExpressionT}
  \HaskellResult							{ShiftExpressionT}
\EndHaskellToken

\BeginHaskellToken	{RightShift}				{Void}	{}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellToken		{{->>-}}				{Ord}	{\CKeyword{>{}>}}
  \HaskellArgument							{AdditiveExpressionT}
  \HaskellResult							{ShiftExpressionT}
\EndHaskellToken

\NewHaskellToken	{`LeftShift`}				{Ord}	{\CKeyword{<{}<}}
\NewHaskellToken	{`RightShift`}				{Ord}	{\CKeyword{>{}>}}

\set{capture}		{ShiftExpressionT}
\begin{code}
data ShiftExpressionT =
	E11 (AdditiveExpressionT)
	| LeftShift  (ShiftExpressionT) {-<<-} (AdditiveExpressionT)
	| RightShift (ShiftExpressionT) {->>-} (AdditiveExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{RelationalExpressionT}			{Ord}	{«relational-expression»}
\NewHaskellResult	{RelationalExpressionT}				{Type}
\NewVariable		{relational_expression}

\BeginHaskellToken	{E10}					{Void}	{}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellResult							{RelationalExpressionT}
\EndHaskellToken

\BeginHaskellToken	{LessThan}				{Void}	{}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellToken		{{-<-}}					{Ord}	{\CKeyword{<}}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellResult							{RelationalExpressionT}
\EndHaskellToken

\BeginHaskellToken	{GreaterThan}				{Void}	{}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellToken		{{->-}}					{Ord}	{\CKeyword{>}}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellResult							{RelationalExpressionT}
\EndHaskellToken

\BeginHaskellToken	{LessOrEqualTo}				{Void}	{}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellToken		{{-<=-}}				{Ord}	{\CKeyword{<=}}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellResult							{RelationalExpressionT}
\EndHaskellToken

\BeginHaskellToken	{GreaterOrEqualTo}			{Void}	{}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellToken		{{->=-}}				{Ord}	{\CKeyword{>=}}
  \HaskellArgument							{ShiftExpressionT}
  \HaskellResult							{RelationalExpressionT}
\EndHaskellToken

\NewHaskellToken	{`LessThan`}				{Ord}	{\CKeyword{<}}
\NewHaskellToken	{`GreaterThan`}				{Ord}	{\CKeyword{>}}
\NewHaskellToken	{`LessOrEqualTo`}			{Ord}	{\CKeyword{<=}}
\NewHaskellToken	{`GreaterOrEqualTo`}			{Ord}	{\CKeyword{>=}}

\set{capture}		{RelationalExpressionT}
\begin{code}
data RelationalExpressionT =
	E10 (ShiftExpressionT)
	| LessThan         (RelationalExpressionT) {-<-}   (ShiftExpressionT)
	| GreaterThan      (RelationalExpressionT) {->-}   (ShiftExpressionT)
	| LessOrEqualTo    (RelationalExpressionT) {-<=-}  (ShiftExpressionT)
	| GreaterOrEqualTo (RelationalExpressionT) {->=-}  (ShiftExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{EqualityExpressionT}			{Ord}	{«equality-expression»}
\NewHaskellResult	{EqualityExpressionT}				{Type}
\NewVariable		{equality_expression}

\BeginHaskellToken	{E9}					{Void}	{}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellResult							{EqualityExpressionT}
\EndHaskellToken

\BeginHaskellToken	{EqualTo}				{Void}	{}
  \HaskellArgument							{EqualityExpressionT}
  \HaskellToken		{{-==-}}				{Ord}	{\CKeyword{==}}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellResult							{EqualityExpressionT}
\EndHaskellToken

\BeginHaskellToken	{NotEqualTo}				{Void}	{}
  \HaskellArgument							{EqualityExpressionT}
  \HaskellToken		{{-!=-}}				{Ord}	{\CKeyword{!=}}
  \HaskellArgument							{RelationalExpressionT}
  \HaskellResult							{EqualityExpressionT}
\EndHaskellToken

\NewHaskellToken	{`EqualTo`}				{Ord}	{\CKeyword{==}}
\NewHaskellToken	{`NotEqualTo`}				{Ord}	{\CKeyword{!=}}

\set{capture}		{EqualityExpressionT}
\begin{code}
data EqualityExpressionT =
	E9 (RelationalExpressionT)
	| EqualTo    (EqualityExpressionT) {-==-}  (RelationalExpressionT)
	| NotEqualTo (EqualityExpressionT) {-!=-}  (RelationalExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{AndExpressionT}			{Ord}	{«AND-expression»}
\NewHaskellResult	{AndExpressionT}				{Type}
\NewVariable		{and_expression}

\BeginHaskellToken	{E8}					{Void}	{}
  \HaskellArgument							{EqualityExpressionT}
  \HaskellResult							{AndExpressionT}
\EndHaskellToken

\BeginHaskellToken	{And}					{Void}	{}
  \HaskellArgument							{AndExpressionT}
  \HaskellToken		{{-\&-}}				{Ord}	{\CKeyword{\&}}
  \HaskellArgument							{EqualityExpressionT}
  \HaskellResult							{AndExpressionT}
\EndHaskellToken

\NewHaskellToken	{`And`}					{Ord}	{\CKeyword{\&}}

\set{capture}		{AndExpressionT}
\begin{code}
data AndExpressionT =
	E8 (EqualityExpressionT)
	| And (AndExpressionT) {-&-} (EqualityExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ExclusiveOrExpressionT}		{Ord}	{«exclusive-OR-expression»}
\NewHaskellResult	{ExclusiveOrExpressionT}			{Type}
\NewVariable		{exclusive_or_expression}

\BeginHaskellToken	{E7}					{Void}	{}
  \HaskellArgument							{AndExpressionT}
  \HaskellResult							{ExclusiveOrExpressionT}
\EndHaskellToken

\BeginHaskellToken	{ExclusiveOr}				{Void}	{}
  \HaskellArgument							{ExclusiveOrExpressionT}
  \HaskellToken		{{-\^-}}				{Ord}	{\CKeyword{\^}}
  \HaskellArgument							{AndExpressionT}
  \HaskellResult							{ExclusiveOrExpressionT}
\EndHaskellToken

\NewHaskellToken	{`ExclusiveOr`}				{Ord}	{\CKeyword{\^}}

\set{capture}		{ExclusiveOrExpressionT}
\begin{code}
data ExclusiveOrExpressionT =
	E7 (AndExpressionT)
	| ExclusiveOr (ExclusiveOrExpressionT) {-^-} (AndExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{InclusiveOrExpressionT}		{Ord}	{«inclusive-OR-expression»}
\NewHaskellResult	{InclusiveOrExpressionT}			{Type}
\NewVariable		{inclusive_or_expression}

\BeginHaskellToken	{E6}					{Void}	{}
  \HaskellArgument							{ExclusiveOrExpressionT}
  \HaskellResult							{InclusiveOrExpressionT}
\EndHaskellToken

\BeginHaskellToken	{InclusiveOr}				{Void}	{}
  \HaskellArgument							{InclusiveOrExpressionT}
  \HaskellToken		{{-|-}}					{Ord}	{\CKeyword{|}}
  \HaskellArgument							{ExclusiveOrExpressionT}
  \HaskellResult							{InclusiveOrExpressionT}
\EndHaskellToken

\NewHaskellToken	{`InclusiveOr`}				{Ord}	{\CKeyword{|}}

\set{capture}		{InclusiveOrExpressionT}
\begin{code}
data InclusiveOrExpressionT =
	E6 (ExclusiveOrExpressionT)
	| InclusiveOr (InclusiveOrExpressionT) {-|-} (ExclusiveOrExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{LogicalAndExpressionT}			{Ord}	{«logical-AND-expression»}
\NewHaskellResult	{LogicalAndExpressionT}				{Type}
\NewVariable		{logical_and_expression}

\BeginHaskellToken	{E5}					{Void}	{}
  \HaskellArgument							{InclusiveOrExpressionT}
  \HaskellResult							{LogicalAndExpressionT}
\EndHaskellToken

\BeginHaskellToken	{LogicalAnd}				{Void}	{}
  \HaskellArgument							{LogicalAndExpressionT}
  \HaskellToken		{{-\&\&-}}				{Ord}	{\CKeyword{\&\&}}
  \HaskellArgument							{InclusiveOrExpressionT}
  \HaskellResult							{LogicalAndExpressionT}
\EndHaskellToken

\NewHaskellToken	{`LogicalAnd`}				{Ord}	{\CKeyword{\&\&}}

\set{capture}		{LogicalAndExpressionT}
\begin{code}
data LogicalAndExpressionT =
	E5 (InclusiveOrExpressionT)
	| LogicalAnd (LogicalAndExpressionT) {-&&-} (InclusiveOrExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{LogicalOrExpressionT}			{Ord}	{«logical-OR-expression»}
\NewHaskellResult	{LogicalOrExpressionT}				{Type}
\NewVariable		{logical_or_expression}

\BeginHaskellToken	{E4}					{Void}	{}
  \HaskellArgument							{LogicalAndExpressionT}
  \HaskellResult							{LogicalOrExpressionT}
\EndHaskellToken

\BeginHaskellToken	{LogicalOr}				{Void}	{}
  \HaskellArgument							{LogicalOrExpressionT}
  \HaskellToken		{{-||-}}				{Ord}	{\CKeyword{\,|\!\!|\,}}
  \HaskellArgument							{LogicalAndExpressionT}
  \HaskellResult							{LogicalOrExpressionT}
\EndHaskellToken

\NewHaskellToken	{`LogicalOr`}				{Ord}	{\CKeyword{\,|\!\!|\,}}

\set{capture}		{LogicalOrExpressionT}
\begin{code}
data LogicalOrExpressionT =
	E4 (LogicalAndExpressionT)
	| LogicalOr (LogicalOrExpressionT) {-||-} (LogicalAndExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ConditionalExpressionT}		{Ord}	{«conditional-expression»}
\NewHaskellResult	{ConditionalExpressionT}			{Type}
\NewVariable		{conditional_expression}

\BeginHaskellToken	{E3}					{Void}	{}
  \HaskellArgument							{LogicalOrExpressionT}
  \HaskellResult							{ConditionalExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Conditional}				{Void}	{}
  \HaskellArgument							{LogicalOrExpressionT}
  \HaskellToken		{{-?-}}					{Ord}	{\CKeyword{?}}
  \HaskellArgument							{ExpressionT}
  \HaskellToken		{{-:-}}					{Ord}	{\CKeyword{:}}
  \HaskellArgument							{ConditionalExpressionT}
  \HaskellResult							{ConditionalExpressionT}
\EndHaskellToken

\set{capture}		{ConditionalExpressionT}
\begin{code}
data ConditionalExpressionT =
	E3 (LogicalOrExpressionT)
	| Conditional (LogicalOrExpressionT) {-?-} (ExpressionT) {-:-} (ConditionalExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{AssignmentExpressionT}			{Ord}	{«assignment-expression»}
\NewHaskellResult	{AssignmentExpressionT}				{Type}
\NewVariable		{assignment_expression}

\BeginHaskellToken	{E2}					{Void}	{}
  \HaskellArgument							{ConditionalExpressionT}
  \HaskellResult							{AssignmentExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Assignment}				{Void}	{}
  \HaskellArgument							{UnaryExpressionT}
  \HaskellArgument							{AssignmentOperatorT}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{AssignmentExpressionT}
\EndHaskellToken

\set{capture}		{AssignmentExpressionT}
\begin{code}
data AssignmentExpressionT =
	E2 (ConditionalExpressionT)
	| Assignment (UnaryExpressionT) (AssignmentOperatorT) (AssignmentExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{AssignmentOperatorT}			{Ord}	{«assignment-operator»}
\NewHaskellResult	{AssignmentOperatorT}				{Type}

\NewHaskellToken	{SimpleAssignment}			{Ord}	{\CKeyword{=}}
\NewHaskellResult	{SimpleAssignment}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundProduct}			{Ord}	{\CKeyword{*=}}
\NewHaskellResult	{CompoundProduct}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundQuotient}			{Ord}	{\CKeyword{/=}}
\NewHaskellResult	{CompoundQuotient}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundRemainder}			{Ord}	{\CKeyword{\%=}}
\NewHaskellResult	{CompoundRemainder}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundSum}				{Ord}	{\CKeyword{+=}}
\NewHaskellResult	{CompoundSum}					{AssignmentOperatorT}
\NewHaskellToken	{CompoundDifference}			{Ord}	{\CKeyword{-=}}
\NewHaskellResult	{CompoundDifference}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundLeftShift}			{Ord}	{\CKeyword{<{}<=}}
\NewHaskellResult	{CompoundLeftShift}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundRightShift}			{Ord}	{\CKeyword{>{}>=}}
\NewHaskellResult	{CompoundRightShift}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundAnd}				{Ord}	{\CKeyword{\&=}}
\NewHaskellResult	{CompoundAnd}					{AssignmentOperatorT}
\NewHaskellToken	{CompoundExclusiveOr}			{Ord}	{\CKeyword{\^=}}
\NewHaskellResult	{CompoundExclusiveOr}				{AssignmentOperatorT}
\NewHaskellToken	{CompoundInclusiveOr}			{Ord}	{\CKeyword{|=}}
\NewHaskellResult	{CompoundInclusiveOr}				{AssignmentOperatorT}

\set{capture}		{AssignmentOperatorT}
\begin{code}
data AssignmentOperatorT {-one-of-} =
	SimpleAssignment {-alt-}| CompoundProduct {-alt-}| CompoundQuotient {-alt-}| CompoundRemainder {-alt-}| --
	CompoundSum {-alt-}| CompoundDifference {-alt-}| CompoundLeftShift {-alt-}| CompoundRightShift {-alt-}| --
	CompoundAnd {-alt-}| CompoundExclusiveOr {-alt-}| CompoundInclusiveOr deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ExpressionT}				{Ord}	{«expression»}
\NewHaskellResult	{ExpressionT}					{Type}
\NewVariable		{expression}

\BeginHaskellToken	{E1}					{Void}	{}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{ExpressionT}
\EndHaskellToken

\BeginHaskellToken	{Comma}					{Void}	{}
  \HaskellArgument							{ExpressionT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{ExpressionT}
\EndHaskellToken

\NewHaskellToken	{`Comma`}				{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{ExpressionT}
\begin{code}
data ExpressionT =
	E1 (AssignmentExpressionT)
	| Comma (ExpressionT) {-,-} (AssignmentExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ConstantExpressionT}			{Ord}	{«constant-expression»}
\NewHaskellResult	{ConstantExpressionT}				{Type}
\NewVariable		{constant_expression}

\BeginHaskellToken	{ConstantExpressionT'}			{Void}	{}
  \HaskellArgument							{ConditionalExpressionT}
  \HaskellResult							{ConstantExpressionT}
\EndHaskellToken

\set{capture}		{ConstantExpressionT}
\begin{code}
type ConstantExpressionT =
	ConditionalExpressionT
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DeclarationT}				{Ord}	{«declaration»}
\NewHaskellResult	{DeclarationT}					{Type}
\NewVariable		{declaration}

\BeginHaskellToken	{Declaration}				{Void}	{}
  \HaskellArgument							{DeclarationSpecifiersT}
  \HaskellArgument							{Maybe InitDeclaratorListT}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{DeclarationT}
\EndHaskellToken

\set{capture}		{DeclarationT}
\begin{code}
data DeclarationT =
	Declaration (DeclarationSpecifiersT) (Maybe InitDeclaratorListT) {-;-} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DeclarationSpecifiersT}		{Ord}	{«declaration-specifiers»}
\NewHaskellResult	{DeclarationSpecifiersT}			{Type}
\NewVariable		{declaration_specifiers}

\BeginHaskellToken	{DeclarationStorageClass}		{Void}	{}
  \HaskellArgument							{StorageClassSpecifierT}
  \HaskellArgument							{Maybe DeclarationSpecifiersT}
  \HaskellResult							{DeclarationSpecifiersT}
\EndHaskellToken  

\BeginHaskellToken	{DeclarationSpecifier}			{Void}	{}
  \HaskellArgument							{TypeSpecifierT}
  \HaskellArgument							{Maybe DeclarationSpecifiersT}
  \HaskellResult							{DeclarationSpecifiersT}
\EndHaskellToken  

\BeginHaskellToken	{DeclarationQualifier}			{Void}	{}
  \HaskellArgument							{TypeQualifierT}
  \HaskellArgument							{Maybe DeclarationSpecifiersT}
  \HaskellResult							{DeclarationSpecifiersT}
\EndHaskellToken  

\set{capture}		{DeclarationSpecifiersT}
\begin{code}
data DeclarationSpecifiersT =
	DeclarationStorageClass (StorageClassSpecifierT) (Maybe DeclarationSpecifiersT)
	| DeclarationSpecifier (TypeSpecifierT)  (Maybe DeclarationSpecifiersT)
	| DeclarationQualifier (TypeQualifierT)  (Maybe DeclarationSpecifiersT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{InitDeclaratorListT}			{Ord}	{«init-declarator-list»}
\NewHaskellResult	{InitDeclaratorListT}				{Type}
\NewVariable		{init_declarator_list}

\BeginHaskellToken	{IR0}					{Void}	{}
  \HaskellArgument							{InitDeclaratorT}
  \HaskellResult							{InitDeclaratorListT}
\EndHaskellToken

\BeginHaskellToken	{IRn}					{Void}	{}
  \HaskellArgument							{InitDeclaratorListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{InitDeclaratorT}
  \HaskellResult							{InitDeclaratorListT}
\EndHaskellToken

\NewHaskellToken	{`IRn`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{InitDeclaratorListT}
\begin{code}
data InitDeclaratorListT =
	IR0 (InitDeclaratorT)
	| IRn (InitDeclaratorListT) {-,-} (InitDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{InitDeclaratorT}			{Ord}	{«init-declarator»}
\NewHaskellResult	{InitDeclaratorT}				{Type}
\NewVariable		{init_declarator}

\BeginHaskellToken	{DefaultDeclarator}			{Void}	{}
  \HaskellArgument							{DeclaratorT}
  \HaskellResult							{InitDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{InitDeclarator}			{Void}	{}
  \HaskellArgument							{DeclaratorT}
  \HaskellToken		{{-=-}}					{Ord}	{\CKeyword{=}}
  \HaskellArgument							{InitialiserT}
  \HaskellResult							{InitDeclaratorT}
\EndHaskellToken  

\NewHaskellToken	{`InitDeclarator`}			{Ord}	{\CKeyword{=}}

\set{capture}		{InitDeclaratorT}
\begin{code}
data InitDeclaratorT =
	DefaultDeclarator (DeclaratorT)
	| InitDeclarator (DeclaratorT) {-=-} (InitialiserT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StorageClassSpecifierT}		{Ord}	{«storage-class-specifier»}
\NewHaskellResult	{StorageClassSpecifierT}			{Type}
\NewVariable		{storage_class_specifier}

\NewHaskellToken	{TypedefSpecifier}			{Ord}	{\CKeyword{typedef}}
\NewHaskellResult	{TypedefSpecifier}				{StorageClassSpecifierT}
\NewHaskellToken	{ExternSpecifier}			{Ord}	{\CKeyword{extern}}
\NewHaskellResult	{ExternSpecifier}				{StorageClassSpecifierT}
\NewHaskellToken	{StaticSpecifier}			{Ord}	{\CKeyword{static}}
\NewHaskellResult	{StaticSpecifier}				{StorageClassSpecifierT}
\NewHaskellToken	{AutoSpecifier}				{Ord}	{\CKeyword{auto}}
\NewHaskellResult	{AutoSpecifier}					{StorageClassSpecifierT}
\NewHaskellToken	{RegisterSpecifier}			{Ord}	{\CKeyword{register}}
\NewHaskellResult	{RegisterSpecifier}				{StorageClassSpecifierT}

\set{capture}		{StorageClassSpecifierT}
\begin{code}
data StorageClassSpecifierT =
	TypedefSpecifier 
	| ExternSpecifier 
	| StaticSpecifier 
	| AutoSpecifier 
	| RegisterSpecifier deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypeSpecifierT}			{Ord}	{«type-specifier»}
\NewHaskellResult	{TypeSpecifierT}				{Type}
\NewVariable		{type_specifier}

\NewHaskellToken	{VoidSpecifier}				{Ord}	{\CKeyword{void}}
\NewHaskellResult	{VoidSpecifier}					{TypeSpecifierT}
\NewHaskellToken	{CharSpecifier}				{Ord}	{\CKeyword{char}}
\NewHaskellResult	{CharSpecifier}					{TypeSpecifierT}
\NewHaskellToken	{ShortSpecifier}			{Ord}	{\CKeyword{short}}
\NewHaskellResult	{ShortSpecifier}				{TypeSpecifierT}
\NewHaskellToken	{IntSpecifier}				{Ord}	{\CKeyword{int}}
\NewHaskellResult	{IntSpecifier}					{TypeSpecifierT}
\NewHaskellToken	{LongSpecifier}				{Ord}	{\CKeyword{long}}
\NewHaskellResult	{LongSpecifier}					{TypeSpecifierT}
\NewHaskellToken	{FloatSpecifier}			{Ord}	{\CKeyword{float}}
\NewHaskellResult	{FloatSpecifier}				{TypeSpecifierT}
\NewHaskellToken	{DoubleSpecifier}			{Ord}	{\CKeyword{double}}
\NewHaskellResult	{DoubleSpecifier}				{TypeSpecifierT}
\NewHaskellToken	{SignedSpecifier}			{Ord}	{\CKeyword{signed}}
\NewHaskellResult	{SignedSpecifier}				{TypeSpecifierT}
\NewHaskellToken	{UnsignedSpecifier}			{Ord}	{\CKeyword{unsigned}}
\NewHaskellResult	{UnsignedSpecifier}				{TypeSpecifierT}

\BeginHaskellToken	{StructOrUnionSpecifier}		{Void}	{}
  \HaskellArgument							{StructOrUnionSpecifierT}
  \HaskellResult							{TypeSpecifierT}
\EndHaskellToken

\BeginHaskellToken	{EnumSpecifier}				{Void}	{}
  \HaskellArgument							{EnumSpecifierT}
  \HaskellResult							{TypeSpecifierT}
\EndHaskellToken

\BeginHaskellToken	{TypedefNameSpecifier}			{Void}	{}
  \HaskellArgument							{TypedefNameT}
  \HaskellResult							{TypeSpecifierT}
\EndHaskellToken

\set{capture}		{TypeSpecifierT}
\begin{haskell}
data TypeSpecifierT =
	VoidSpecifier
	| CharSpecifier
	| ShortSpecifier
	| IntSpecifier
	| LongSpecifier
	| FloatSpecifier
	| DoubleSpecifier
	| SignedSpecifier
	| UnsignedSpecifier
	| StructOrUnionSpecifier (StructOrUnionSpecifierT)
	| EnumSpecifier (EnumSpecifierT)
	| TypedefNameSpecifier (TypedefNameT) deriving (Eq, Ord, Show)
\end{haskell}

\set{capture}		{hidden}
\begin{code}
data TypeSpecifierT {-one-of-} =
	SignedSpecifier		{-alt-}|  UnsignedSpecifier 	{-alt-}|
	ShortSpecifier		{-alt-}|  LongSpecifier		{-alt-}|
	VoidSpecifier		{-alt-}|  CharSpecifier 	{-alt-}|  IntSpecifier  {-alt-}|  FloatSpecifier  {-alt-}|  DoubleSpecifier  {-alt-}|
	StructOrUnionSpecifier (StructOrUnionSpecifierT) {-alt-}| EnumSpecifier (EnumSpecifierT) {-alt-}| TypedefNameSpecifier (TypedefNameT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructOrUnionSpecifierT}		{Ord}	{«struct-or-union-specifier»}
\NewHaskellResult	{StructOrUnionSpecifierT}			{Type}
\NewVariable		{struct_or_union_specifier}

\BeginHaskellToken	{StructOrUnion}				{Void}	{}
  \HaskellArgument							{StructOrUnionT}
  \HaskellArgument							{Maybe IdentifierT}
  \BeginHaskellParens						{Open}	{\CKeyword{\{}\WhiteSpace}
    \RawHaskellArgument							{StructDeclarationListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\}}}
  \HaskellResult							{StructOrUnionSpecifierT}
\EndHaskellToken

\BeginHaskellToken	{StructOrUnionTag}			{Void}	{}
  \HaskellArgument							{StructOrUnionT}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{StructOrUnionSpecifierT}
\EndHaskellToken

\set{capture}		{StructOrUnionSpecifierT}
\begin{code}
data StructOrUnionSpecifierT =
	StructOrUnion (StructOrUnionT) (Maybe IdentifierT) (StructDeclarationListT)
	| StructOrUnionTag (StructOrUnionT) (IdentifierT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructOrUnionT}			{Ord}	{«struct-or-union»}
\NewHaskellResult	{StructOrUnionT}				{Type}
\NewVariable		{struct_or_union}

\NewHaskellToken	{Struct}				{Ord}	{\CKeyword{struct}}
\NewHaskellResult	{Struct}					{StructOrUnionT}
\NewHaskellToken	{Union}					{Ord}	{\CKeyword{union}}
\NewHaskellResult	{Union}						{StructOrUnionT}

\set{capture}		{StructOrUnionT}
\begin{code}
data StructOrUnionT =
	Struct
	| Union deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructDeclarationListT}		{Ord}	{«struct-declaration-list»}
\NewHaskellResult	{StructDeclarationListT}			{Type}
\NewVariable		{struct_declaration_list}

\BeginHaskellToken	{SD0}					{Void}	{}
  \HaskellArgument							{StructDeclarationT}
  \HaskellResult							{StructDeclarationListT}
\EndHaskellToken

\BeginHaskellToken	{SDn}					{Void}	{}
  \HaskellArgument							{StructDeclarationListT}
  \HaskellArgument							{StructDeclarationT}
  \HaskellResult							{StructDeclarationListT}
\EndHaskellToken

\NewHaskellToken	{`SDn`}					{Void}	{}

\set{capture}		{StructDeclarationListT}
\begin{code}
data StructDeclarationListT =
	SD0 (StructDeclarationT)
	| SDn (StructDeclarationListT) (StructDeclarationT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructDeclarationT}			{Ord}	{«struct-declaration»}
\NewHaskellResult	{StructDeclarationT}				{Type}
\NewVariable		{struct_declaration}

\BeginHaskellToken	{StructDeclaration}			{Void}	{}
  \HaskellArgument							{SpecifierQualifierListT}
  \HaskellArgument							{StructDeclaratorListT}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{StructDeclarationT}
\EndHaskellToken

\set{capture}		{StructDeclarationT}
\begin{code}
data StructDeclarationT =
	StructDeclaration (SpecifierQualifierListT) (StructDeclaratorListT) {-;-} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{SpecifierQualifierListT}		{Ord}	{«specifier-qualifier-list»}
\NewHaskellResult	{SpecifierQualifierListT}			{Type}
\NewVariable		{specifier_qualifier_list}

\BeginHaskellToken	{Specifier}				{Void}	{}
  \HaskellArgument							{TypeSpecifierT}
  \HaskellArgument							{Maybe SpecifierQualifierListT}
  \HaskellResult							{SpecifierQualifierListT}
\EndHaskellToken

\BeginHaskellToken	{Qualifier}				{Void}	{}
  \HaskellArgument							{TypeQualifierT}
  \HaskellArgument							{Maybe SpecifierQualifierListT}
  \HaskellResult							{SpecifierQualifierListT}
\EndHaskellToken

\set{capture}		{SpecifierQualifierListT}
\begin{code}
data SpecifierQualifierListT =
	Specifier (TypeSpecifierT) (Maybe SpecifierQualifierListT)
	| Qualifier (TypeQualifierT) (Maybe SpecifierQualifierListT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructDeclaratorListT}			{Ord}	{«struct-declarator-list»}
\NewHaskellResult	{StructDeclaratorListT}				{Type}
\NewVariable		{struct_declarator_list}

\BeginHaskellToken	{SR0}					{Void}	{}
  \HaskellArgument							{StructDeclaratorT}
  \HaskellResult							{StructDeclaratorListT}
\EndHaskellToken

\BeginHaskellToken	{SRn}					{Void}	{}
  \HaskellArgument							{StructDeclaratorListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{StructDeclaratorT}
  \HaskellResult							{StructDeclaratorListT}
\EndHaskellToken

\NewHaskellToken	{`SRn`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{StructDeclaratorListT}
\begin{code}
data StructDeclaratorListT =
	SR0 (StructDeclaratorT)
	| SRn (StructDeclaratorListT) {-,-} (StructDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StructDeclaratorT}			{Ord}	{«struct-declarator»}
\NewHaskellResult	{StructDeclaratorT}				{Type}
\NewVariable		{struct_declarator}

\BeginHaskellToken	{StructDeclarator}			{Void}	{}
  \HaskellArgument							{DeclaratorT}
  \HaskellResult							{StructDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{BitFieldDeclarator}			{Void}	{}
  \HaskellArgument							{Maybe DeclaratorT}
  \HaskellToken		{{-:-}}					{Ord}	{\CKeyword{:}}
  \HaskellArgument							{ConstantExpressionT}
  \HaskellResult							{StructDeclaratorT}
\EndHaskellToken

\NewHaskellToken	{`BitFieldDeclarator`}			{Ord}	{\CKeyword{:}}

\set{capture}		{StructDeclaratorT}
\begin{code}
data StructDeclaratorT =
	StructDeclarator (DeclaratorT)
	| BitFieldDeclarator (Maybe DeclaratorT) {-:-} (ConstantExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{EnumSpecifierT}			{Ord}	{«enum-specifier»}
\NewHaskellResult	{EnumSpecifierT}				{Type}
\NewVariable		{enum_specifier}

\BeginHaskellToken	{Enumeration}				{Ord}	{\CKeyword{enum}}
  \HaskellArgument							{Maybe IdentifierT}
  \BeginHaskellParens						{Open}	{\CKeyword{\{}\WhiteSpace}
    \RawHaskellArgument							{EnumeratorListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\}}}
  \HaskellResult							{EnumSpecifierT}
\EndHaskellToken

\BeginHaskellToken	{EnumerationTag}			{Ord}	{\CKeyword{enum}}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{EnumSpecifierT}
\EndHaskellToken

\set{capture}		{EnumSpecifierT}
\begin{code}
data EnumSpecifierT =
	Enumeration (Maybe IdentifierT) (EnumeratorListT)
	| EnumerationTag (IdentifierT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{EnumeratorListT}			{Ord}	{«enumerator-list»}
\NewHaskellResult	{EnumeratorListT}				{Type}
\NewVariable		{enumerator_list}

\BeginHaskellToken	{N0}					{Void}	{}
  \HaskellArgument							{EnumeratorT}
  \HaskellResult							{EnumeratorListT}
\EndHaskellToken

\BeginHaskellToken	{Nn}					{Void}	{}
  \HaskellArgument							{EnumeratorListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{EnumeratorT}
  \HaskellResult							{EnumeratorListT}
\EndHaskellToken

\NewHaskellToken	{`Nn`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{EnumeratorListT}
\begin{code}
data EnumeratorListT =
	N0 (EnumeratorT)
	| Nn (EnumeratorListT) {-,-} (EnumeratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{EnumeratorT}				{Ord}	{«enumerator»}
\NewHaskellResult	{EnumeratorT}					{Type}
\NewVariable		{enumerator}

\BeginHaskellToken	{DefaultEnumerator}			{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{EnumeratorT}
\EndHaskellToken

\BeginHaskellToken	{InitEnumerator}			{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellToken		{{-=-}}					{Ord}	{\CKeyword{=}}
  \HaskellArgument							{ConstantExpressionT}
  \HaskellResult							{EnumeratorT}
\EndHaskellToken

\NewHaskellToken	{`InitEnumerator`}			{Ord}	{\CKeyword{=}}

\set{capture}		{EnumeratorT}
\begin{code}
data EnumeratorT =
	DefaultEnumerator (IdentifierT)
	| InitEnumerator (IdentifierT) {-=-} (ConstantExpressionT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypeQualifierT}			{Ord}	{«type-qualifier»}
\NewHaskellResult	{TypeQualifierT}				{Type}
\NewVariable		{type_qualifier}

\NewHaskellToken	{ConstQualifier}			{Ord}	{\CKeyword{const}}
\NewHaskellResult	{ConstQualifier}				{TypeQualifierT}
\NewHaskellToken	{VolatileQualifier}			{Ord}	{\CKeyword{volatile}}
\NewHaskellResult	{VolatileQualifier}				{TypeQualifierT}

\set{capture}		{TypeQualifierT}
\begin{code}
data TypeQualifierT =
	ConstQualifier
	| VolatileQualifier deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DeclaratorT}				{Ord}	{«declarator»}
\NewHaskellResult	{DeclaratorT}					{Type}
\NewVariable		{declarator}

\BeginHaskellToken	{Declarator}				{Void}	{}
  \HaskellArgument							{Maybe PointerT}
  \HaskellArgument							{DirectDeclaratorT}
  \HaskellResult							{DeclaratorT}
\EndHaskellToken

\set{capture}		{DeclaratorT}
\begin{code}
data DeclaratorT =
	Declarator (Maybe PointerT) (DirectDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DirectDeclaratorT}			{Ord}	{«direct-declarator»}
\NewHaskellResult	{DirectDeclaratorT}				{Type}
\NewVariable		{direct_declarator}

\BeginHaskellToken	{IdentifierDeclarator}			{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{DirectDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{NestedDeclarator}			{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{DeclaratorT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{DirectDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{ArrayDeclarator}			{Void}	{}
  \HaskellArgument							{DirectDeclaratorT}
  \BeginHaskellParens						{Open}	{\CKeyword{\[}\WhiteSpace}
    \RawHaskellArgument							{Maybe ConstantExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
  \HaskellResult							{DirectDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{`ArrayDeclarator`}			{Op}	{\!}
  \BeginHaskellParens						{Open}	{\CKeyword{\[}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
\EndHaskellToken
	
\BeginHaskellToken	{PrototypeDeclarator}			{Void}	{}
  \HaskellArgument							{DirectDeclaratorT}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ParameterTypeListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{DirectDeclaratorT}
\EndHaskellToken
	
\BeginHaskellToken	{`PrototypeDeclarator`}			{Op}	{\!}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
\EndHaskellToken
		
\BeginHaskellToken	{FunctionDeclarator}			{Void}	{}
  \HaskellArgument							{DirectDeclaratorT}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \HaskellArgument							{Maybe IdentifierListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{DirectDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{`FunctionDeclarator`}			{Op}	{\!}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
\EndHaskellToken

\set{capture}		{DirectDeclaratorT}
\begin{code}
data DirectDeclaratorT =
	IdentifierDeclarator (IdentifierT)
	| NestedDeclarator (DeclaratorT)
	| ArrayDeclarator (DirectDeclaratorT) (Maybe ConstantExpressionT)
	| PrototypeDeclarator (DirectDeclaratorT) (ParameterTypeListT)
	| FunctionDeclarator (DirectDeclaratorT) (Maybe IdentifierListT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{PointerT}				{Ord}	{«pointer»}
\NewHaskellResult	{PointerT}					{Type}
\NewVariable		{pointer}

\BeginHaskellToken	{Pointer}				{Ord}	{\CKeyword{*}}
  \HaskellArgument							{Maybe TypeQualifierListT}
  \HaskellResult							{PointerT}
\EndHaskellToken

\BeginHaskellToken	{Pointers}				{Ord}	{\CKeyword{*}}
  \HaskellArgument							{Maybe TypeQualifierListT}
  \HaskellArgument							{PointerT}
  \HaskellResult							{PointerT}
\EndHaskellToken

\set{capture}		{PointerT}
\begin{code}
data PointerT =
	Pointer (Maybe TypeQualifierListT)
	| Pointers (Maybe TypeQualifierListT) (PointerT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypeQualifierListT}			{Ord}	{«type-qualifier-list»}
\NewHaskellResult	{TypeQualifierListT}				{Type}
\NewVariable		{type_qualifier_list}

\BeginHaskellToken	{Q0}					{Void}	{}
  \HaskellArgument							{TypeQualifierT}
  \HaskellResult							{TypeQualifierListT}
\EndHaskellToken

\BeginHaskellToken	{Qn}					{Void}	{}
  \HaskellArgument							{TypeQualifierListT}
  \HaskellArgument							{TypeQualifierT}
  \HaskellResult							{TypeQualifierListT}
\EndHaskellToken

\NewHaskellToken	{`Qn`}					{Void}	{}

\set{capture}		{TypeQualifierListT}
\begin{code}
data TypeQualifierListT =
	Q0 (TypeQualifierT)
	| TypeQualifierListT `Qn` TypeQualifierT deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ParameterTypeListT}			{Ord}	{«parameter-type-list»}
\NewHaskellResult	{ParameterTypeListT}				{Type}
\NewVariable		{parameter_type_list}

\BeginHaskellToken	{FixedParameters}				{Void}	{}
  \HaskellArgument							{ParameterListT}
  \HaskellResult							{ParameterTypeListT}
\EndHaskellToken

\BeginHaskellToken	{VariableParameters}			{Void}	{}
  \HaskellArgument							{ParameterListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellToken		{{-...-}}				{Ord}	{\CKeyword{...}}
  \HaskellResult							{ParameterTypeListT}
\EndHaskellToken

\set{capture}		{ParameterTypeListT}
\begin{code}
data ParameterTypeListT =
	FixedParameters (ParameterListT)
	| VariableParameters (ParameterListT) {-,-} {-...-} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ParameterListT}			{Ord}	{«parameter-list»}
\NewHaskellResult	{ParameterListT}				{Type}
\NewVariable		{parameter_list}

\BeginHaskellToken	{P0}					{Void}	{}
  \HaskellArgument							{ParameterDeclarationT}
  \HaskellResult							{ParameterListT}
\EndHaskellToken

\BeginHaskellToken	{Pn}					{Void}	{}
  \HaskellArgument							{ParameterListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{ParameterDeclarationT}
  \HaskellResult							{ParameterListT}
\EndHaskellToken

\NewHaskellToken	{`Pn`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{ParameterListT}
\begin{code}
data ParameterListT =
	P0 (ParameterDeclarationT)
	| Pn (ParameterListT) {-,-} (ParameterDeclarationT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ParameterDeclarationT}			{Ord}	{«parameter-declaration»}
\NewHaskellResult	{ParameterDeclarationT}				{Type}
\NewVariable		{parameter_declaration}

\BeginHaskellToken	{NamedParameter}			{Void}	{}
  \HaskellArgument							{DeclarationSpecifiersT}
  \HaskellArgument							{DeclaratorT}
  \HaskellResult							{ParameterDeclarationT}
\EndHaskellToken

\BeginHaskellToken	{AbstractParameter}			{Void}	{}
  \HaskellArgument							{DeclarationSpecifiersT}
  \HaskellArgument							{Maybe AbstractDeclaratorT}
  \HaskellResult							{ParameterDeclarationT}
\EndHaskellToken

\set{capture}		{ParameterDeclarationT}
\begin{code}
data ParameterDeclarationT =
	NamedParameter (DeclarationSpecifiersT) (DeclaratorT)
	| AbstractParameter (DeclarationSpecifiersT) (Maybe AbstractDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{IdentifierListT}			{Ord}	{«identifier-list»}
\NewHaskellResult	{IdentifierListT}				{Type}
\NewVariable		{identifier_list}

\BeginHaskellToken	{X0}					{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{IdentifierListT}
\EndHaskellToken

\BeginHaskellToken	{Xn}					{Void}	{}
  \HaskellArgument							{IdentifierListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{IdentifierListT}
\EndHaskellToken

\NewHaskellToken	{`Xn`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{IdentifierListT}
\begin{code}
data IdentifierListT =
	X0 (IdentifierT)
	| Xn (IdentifierListT) {-,-} (IdentifierT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypeNameT}				{Ord}	{«type-name»}
\NewHaskellResult	{TypeNameT}					{Type}
\NewVariable		{type_name}

\BeginHaskellToken	{TypeName}				{Void}	{}
  \HaskellArgument							{SpecifierQualifierListT}
  \HaskellArgument							{Maybe AbstractDeclaratorT}
  \HaskellResult							{TypeNameT}
\EndHaskellToken

\set{capture}		{TypeNameT}
\begin{code}
data TypeNameT =
	TypeName (SpecifierQualifierListT) (Maybe AbstractDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{AbstractDeclaratorT}			{Ord}	{«abstract-declarator»}
\NewHaskellResult	{AbstractDeclaratorT}				{Type}
\NewVariable		{abstract_declarator}

\BeginHaskellToken	{AbstractPointer}			{Void}	{}
  \HaskellArgument							{PointerT}
  \HaskellResult							{AbstractDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{AbstractDeclarator}			{Void}	{}
  \HaskellArgument							{Maybe PointerT}
  \HaskellArgument							{DirectAbstractDeclaratorT}
  \HaskellResult							{AbstractDeclaratorT}
\EndHaskellToken

\set{capture}		{AbstractDeclaratorT}
\begin{code}
data AbstractDeclaratorT =
	AbstractPointer (PointerT)
	| AbstractDeclarator (Maybe PointerT) (DirectAbstractDeclaratorT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DirectAbstractDeclaratorT}		{Ord}	{«direct-abstract-declarator»}
\NewHaskellResult	{DirectAbstractDeclaratorT}			{Type}
\NewVariable		{direct_abstract_declarator}

\BeginHaskellToken	{NestedAbstractDeclarator}		{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{AbstractDeclaratorT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{DirectAbstractDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{AbstractArrayDeclarator}		{Void}	{}
  \HaskellArgument							{Maybe DirectAbstractDeclaratorT}
  \BeginHaskellParens						{Open}	{\CKeyword{\[}\WhiteSpace}
    \RawHaskellArgument							{Maybe ConstantExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
  \HaskellResult							{DirectAbstractDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{`AbstractArrayDeclarator`}		{Op}	{\!}
  \BeginHaskellParens						{Open}	{\CKeyword{\[}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\]}}
\EndHaskellToken

\BeginHaskellToken	{AbstractFunctionDeclarator}		{Void}	{}
  \HaskellArgument							{Maybe DirectAbstractDeclaratorT}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{Maybe ParameterTypeListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellResult							{DirectAbstractDeclaratorT}
\EndHaskellToken

\BeginHaskellToken	{`AbstractFunctionDeclarator`}		{Op}	{\!}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
\EndHaskellToken

\set{capture}		{DirectAbstractDeclaratorT}
\begin{code}
data DirectAbstractDeclaratorT =
	NestedAbstractDeclarator (AbstractDeclaratorT)
	| AbstractArrayDeclarator (Maybe DirectAbstractDeclaratorT) (Maybe ConstantExpressionT)
	| AbstractFunctionDeclarator (Maybe DirectAbstractDeclaratorT) (Maybe ParameterTypeListT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TypedefNameT}				{Ord}	{«typedef-name»}
\NewHaskellResult	{TypedefNameT}					{Type}
\NewVariable		{typedef_name}

\BeginHaskellToken	{TypedefNameT'}				{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellResult							{TypedefNameT}
\EndHaskellToken

\set{capture}		{TypedefNameT}
\begin{code}
type TypedefNameT =
	IdentifierT
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{InitialiserT}				{Ord}	{«initialiser»}
\NewHaskellResult	{InitialiserT}					{Type}
\NewVariable		{initialiser}

\BeginHaskellToken	{ExpressionInitialiser}			{Void}	{}
  \HaskellArgument							{AssignmentExpressionT}
  \HaskellResult							{InitialiserT}
\EndHaskellToken

\BeginHaskellToken	{CompoundInitialiser}			{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{\{}\WhiteSpace}
    \RawHaskellArgument							{InitialiserListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\}}}
  \HaskellResult							{InitialiserT}
\EndHaskellToken

\BeginHaskellToken	{CompoundInitialiser'}			{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{\{}\WhiteSpace}
    \RawHaskellArgument							{InitialiserListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{,}\WhiteSpace\CKeyword{\}}}
  \HaskellResult							{InitialiserT}
\EndHaskellToken

\set{capture}		{InitialiserT}
\begin{code}
data InitialiserT =
	ExpressionInitialiser (AssignmentExpressionT)
	| CompoundInitialiser (InitialiserListT)
	| CompoundInitialiser' (InitialiserListT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{InitialiserListT}			{Ord}	{«initialiser-list»}
\NewHaskellResult	{InitialiserListT}				{Type}
\NewVariable		{initialiser_list}

\BeginHaskellToken	{I0}					{Void}	{}
  \HaskellArgument							{InitialiserT}
  \HaskellResult							{InitialiserListT}
\EndHaskellToken

\BeginHaskellToken	{In}					{Void}	{}
  \HaskellArgument							{InitialiserListT}
  \HaskellToken		{{-,-}}					{Close}	{\WhiteSpace\CKeyword{,}}
  \HaskellArgument							{InitialiserT}
  \HaskellResult							{InitialiserListT}
\EndHaskellToken

\NewHaskellToken	{`In`}					{Close}	{\WhiteSpace\CKeyword{,}}

\set{capture}		{InitialiserListT}
\begin{code}
data InitialiserListT =
	I0 (InitialiserT)
	| In (InitialiserListT) {-,-} (InitialiserT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StatementT}				{Ord}	{«statement»}
\NewHaskellResult	{StatementT}					{Type}
\NewVariable		{statement}

\BeginHaskellToken	{S1}					{Void}	{}
  \HaskellArgument							{LabelledStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\BeginHaskellToken	{S2}					{Void}	{}
  \HaskellArgument							{CompoundStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\BeginHaskellToken	{S3}					{Void}	{}
  \HaskellArgument							{ExpressionStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\BeginHaskellToken	{S4}					{Void}	{}
  \HaskellArgument							{SelectionStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\BeginHaskellToken	{S5}					{Void}	{}
  \HaskellArgument							{IterationStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\BeginHaskellToken	{S6}					{Void}	{}
  \HaskellArgument							{JumpStatementT}
  \HaskellResult							{StatementT}
\EndHaskellToken

\set{capture}		{StatementT}
\begin{code}
data StatementT =
	S1 (LabelledStatementT)
	| S2 (CompoundStatementT)
	| S3 (ExpressionStatementT)
	| S4 (SelectionStatementT)
	| S5 (IterationStatementT)
	| S6 (JumpStatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{LabelledStatementT}			{Ord}	{«labelled-statement»}
\NewHaskellResult	{LabelledStatementT}				{Type}
\NewVariable		{labelled_statement}

\BeginHaskellToken	{LabelStatement}			{Void}	{}
  \HaskellArgument							{IdentifierT}
  \HaskellToken		{{-:-}}					{Close}	{\WhiteSpace\CKeyword{:}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{LabelledStatementT}
\EndHaskellToken

\BeginHaskellToken	{CaseStatement}				{Ord}	{\CKeyword{case}}
  \HaskellArgument							{ConstantExpressionT}
  \HaskellToken		{{-:-}}					{Close}	{\WhiteSpace\CKeyword{:}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{LabelledStatementT}
\EndHaskellToken

\BeginHaskellToken	{DefaultStatement}			{Ord}	{\CKeyword{default}}
  \HaskellToken		{{-:-}}					{Close}	{\WhiteSpace\CKeyword{:}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{LabelledStatementT}
\EndHaskellToken

\set{capture}		{LabelledStatementT}
\begin{code}
data LabelledStatementT =
	LabelStatement (IdentifierT) {-:-} (StatementT)
	| CaseStatement (ConstantExpressionT) {-:-} (StatementT)
	| DefaultStatement {-:-} (StatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{CompoundStatementT}			{Ord}	{«compound-statement»}
\NewHaskellResult	{CompoundStatementT}				{Type}
\NewVariable		{compound_statement}

\BeginHaskellToken	{CompoundStatement}			{Void}	{}
  \BeginHaskellParens						{Open}	{\CKeyword{\{}\WhiteSpace}
    \RawHaskellArgument							{Maybe DeclarationListT}
  \EndHaskellParens						{Void}	{}
  \BeginHaskellParens						{Void}	{}
    \RawHaskellArgument							{Maybe StatementListT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{\}}}
  \HaskellResult							{CompoundStatementT}
\EndHaskellToken

\set{capture}		{CompoundStatementT}
\begin{code}
data CompoundStatementT =
	CompoundStatement (Maybe DeclarationListT) (Maybe StatementListT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{DeclarationListT}			{Ord}	{«declaration-list»}
\NewHaskellResult	{DeclarationListT}				{Type}
\NewVariable		{declaration_list}

\BeginHaskellToken	{D0}					{Void}	{}
  \HaskellArgument							{DeclarationT}
  \HaskellResult							{DeclarationListT}
\EndHaskellToken

\BeginHaskellToken	{Dn}					{Void}	{}
  \HaskellArgument							{DeclarationListT}
  \HaskellArgument							{DeclarationT}
  \HaskellResult							{DeclarationListT}
\EndHaskellToken

\NewHaskellToken	{`Dn`}					{Void}	{}

\set{capture}		{DeclarationListT}
\begin{code}
data DeclarationListT =
	D0 (DeclarationT)
	| Dn (DeclarationListT) (DeclarationT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{StatementListT}			{Ord}	{«statement-list»}
\NewHaskellResult	{StatementListT}				{Type}
\NewVariable		{statement_list}

\BeginHaskellToken	{S0}					{Void}	{}
  \HaskellArgument							{StatementT}
  \HaskellResult							{StatementListT}
\EndHaskellToken

\BeginHaskellToken	{Sn}					{Void}	{}
  \HaskellArgument							{StatementListT}
  \HaskellArgument							{StatementT}
  \HaskellResult							{StatementListT}
\EndHaskellToken

\NewHaskellToken	{`Sn`}					{Void}	{}

\set{capture}		{StatementListT}
\begin{code}
data StatementListT =
	S0 (StatementT)
	| Sn (StatementListT) (StatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ExpressionStatementT}			{Ord}	{«expression-statement»}
\NewHaskellResult	{ExpressionStatementT}				{Type}
\NewVariable		{expression_statement}

\BeginHaskellToken	{ExpressionStatement}			{Void}	{}
  \HaskellArgument							{Maybe ExpressionT}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{ExpressionStatementT}
\EndHaskellToken

\set{capture}		{ExpressionStatementT}
\begin{code}
newtype ExpressionStatementT =
	ExpressionStatement (Maybe ExpressionT) {-;-} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{SelectionStatementT}			{Ord}	{«selection-statement»}
\NewHaskellResult	{SelectionStatementT}				{Type}
\NewVariable		{selection_statement}

\BeginHaskellToken	{IfStatement}				{Ord}	{\CKeyword{if}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{SelectionStatementT}
\EndHaskellToken

\BeginHaskellToken	{IfElseStatement}			{Ord}	{\CKeyword{if}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellArgument							{StatementT}
  \HaskellToken		{{-else-}}				{Ord}	{\CKeyword{else}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{SelectionStatementT}
\EndHaskellToken

\BeginHaskellToken	{SwitchStatement}			{Ord}	{\CKeyword{switch}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{SelectionStatementT}
\EndHaskellToken

\set{capture}		{SelectionStatementT}
\begin{code}
data SelectionStatementT =
	IfStatement (ExpressionT) (StatementT)
	| IfElseStatement (ExpressionT) (StatementT) {-else-} (StatementT)
	| SwitchStatement (ExpressionT) (StatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{IterationStatementT}			{Ord}	{«iteration-statement»}
\NewHaskellResult	{IterationStatementT}				{Type}
\NewVariable		{iteration_statement}

\BeginHaskellToken	{WhileStatement}			{Ord}	{\CKeyword{while}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{IterationStatementT}
\EndHaskellToken

\BeginHaskellToken	{DoWhileStatement}			{Ord}	{\CKeyword{do}}
  \HaskellArgument							{StatementT}
  \HaskellToken		{{-while-}}				{Ord}	{\CKeyword{while}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \RawHaskellArgument							{ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{IterationStatementT}
\EndHaskellToken

\BeginHaskellToken	{ForStatement}				{Ord}	{\CKeyword{for}}
  \BeginHaskellParens						{Open}	{\CKeyword{(}\WhiteSpace}
    \HaskellArgument							{Maybe ExpressionT}
    \HaskellToken	{,}					{Close}	{\WhiteSpace\CKeyword{;}}
    \HaskellArgument							{Maybe ExpressionT}
    \HaskellToken	{,}					{Close}	{\WhiteSpace\CKeyword{;}}
    \HaskellArgument							{Maybe ExpressionT}
  \EndHaskellParens						{Close}	{\WhiteSpace\CKeyword{)}}
  \HaskellArgument							{StatementT}
  \HaskellResult							{IterationStatementT}
\EndHaskellToken

\set{capture}		{IterationStatementT}
\begin{code}
data IterationStatementT =
	WhileStatement (ExpressionT) (StatementT)
	| DoWhileStatement (StatementT) {-while-} (ExpressionT) {-;-}
	| ForStatement ((Maybe ExpressionT), (Maybe ExpressionT), (Maybe ExpressionT)) (StatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{JumpStatementT}			{Ord}	{«jump-statement»}
\NewHaskellResult	{JumpStatementT}				{Type}
\NewVariable		{jump_statement}

\BeginHaskellToken	{GotoStatement}				{Ord}	{\CKeyword{goto}}
  \HaskellArgument							{IdentifierT}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{JumpStatementT}
\EndHaskellToken

\BeginHaskellToken	{ContinueStatement}			{Ord}	{\CKeyword{continue}}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{JumpStatementT}
\EndHaskellToken

\BeginHaskellToken	{BreakStatement}			{Ord}	{\CKeyword{break}}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{JumpStatementT}
\EndHaskellToken

\BeginHaskellToken	{ReturnStatement}			{Ord}	{\CKeyword{return}}
  \HaskellArgument							{Maybe ExpressionT}
  \HaskellToken		{{-;-}}					{Close}	{\WhiteSpace\CKeyword{;}}
  \HaskellResult							{JumpStatementT}
\EndHaskellToken

\set{capture}		{JumpStatementT}
\begin{code}
data JumpStatementT =
	GotoStatement (IdentifierT) {-;-}
	| ContinueStatement {-;-}
	| BreakStatement {-;-}
	| ReturnStatement (Maybe ExpressionT) {-;-} deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{TranslationUnitT}			{Ord}	{«translation-unit»}
\NewHaskellResult	{TranslationUnitT}				{Type}
\NewVariable		{translation_unit}

\BeginHaskellToken	{U0}					{Void}	{}
  \HaskellArgument							{ExternalDeclarationT}
  \HaskellResult							{TranslationUnitT}
\EndHaskellToken

\BeginHaskellToken	{Un}					{Void}	{}
  \HaskellArgument							{TranslationUnitT}
  \HaskellArgument							{ExternalDeclarationT}
  \HaskellResult							{TranslationUnitT}
\EndHaskellToken

\NewHaskellToken	{`Un`}					{Void}	{}

\set{capture}		{TranslationUnitT}
\begin{code}
data TranslationUnitT =
	U0 (ExternalDeclarationT)
	| Un (TranslationUnitT) (ExternalDeclarationT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{ExternalDeclarationT}			{Ord}	{«external-declaration»}
\NewHaskellResult	{ExternalDeclarationT}				{Type}
\NewVariable		{external_declaration}

\BeginHaskellToken	{FunctionDefinition}			{Void}	{}
  \HaskellArgument							{FunctionDefinitionT}
  \HaskellResult							{ExternalDeclarationT}
\EndHaskellToken

\BeginHaskellToken	{ExternalDeclaration}			{Void}	{}
  \HaskellArgument							{DeclarationT}
  \HaskellResult							{ExternalDeclarationT}
\EndHaskellToken

\set{capture}		{ExternalDeclarationT}
\begin{code}
data ExternalDeclarationT =
	FunctionDefinition (FunctionDefinitionT)
	| ExternalDeclaration (DeclarationT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NewHaskellToken	{FunctionDefinitionT}			{Ord}	{«function-definition»}
\NewHaskellResult	{FunctionDefinitionT}				{Type}
\NewVariable		{function_definition}

\BeginHaskellToken	{Function}				{Void}	{}
  \HaskellArgument							{Maybe DeclarationSpecifiersT}
  \HaskellArgument							{DeclaratorT}
  \HaskellArgument							{Maybe DeclarationListT}
  \HaskellArgument							{CompoundStatementT}
  \HaskellResult							{FunctionDefinitionT}
\EndHaskellToken

\set{capture}		{FunctionDefinitionT}
\begin{code}
data FunctionDefinitionT =
	Function (Maybe DeclarationSpecifiersT) (DeclaratorT) (Maybe DeclarationListT) (CompoundStatementT) deriving (Eq, Ord, Show)
\end{code}

%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\end{syntax}
