#! /bin/perl

use strict;
use warnings;

my %definitions = ();
my $key = "";
my $block = "";
my $lineno = 0;
my $sep = "";
while (my $line = <>) {
	++$lineno;
	chomp $line;

	$line =~ s/\s+$//;
	
	next if $line eq "";
	next if $line =~ m/^\s*\%/;
	
	if ($line =~ m/^\s*\\set\s*\{label\}\s*\{(.*)([0-9]{2}[a-zA-Z]*)\}$/) {
		my ($key1, $key2) = ($1, $2);
		if ($key2 =~ m/^0.*/) {
			$key = $key1 . "20" . $key2;
		}
		else {
			$key = $key1 . "19" . $key2;
		}
	}
	$block .= $line;
	$block .= "\n";
	
	if ($line =~ m/^\s*\\(begin|end)\s*\{.*\}$/) {
		for $key (sort keys %definitions) {
			print $sep;
			print $definitions{$key};
			$sep = "\n";
		}
		print $sep;
		print $block;
		$sep = "\n";
		%definitions = ();
		$key = "";
		$block = "";		
	}
	elsif ($line =~ m/^\s*\\new\s*\{.*\}$/) {
		if ($key eq "") {
		  	die "No key specified for the block on line $lineno";
		}
		$definitions{$key} = $block;
		$key = "";
		$block = "";
	}
}

if ($block ne "") {
	die "Incomplete block specified on line $lineno";
}

for $key (sort keys %definitions) {
	print $sep;
	print $definitions{$key};
	$sep = "\n";
}

exit 0;
