#! /bin/perl

use strict;
use warnings;

my ($word_count, $code_count, $real_code_count) = (0, 0, 0);
my $in_code = 0;
while (my $line = <>) {
	$line =~ s/^\s+//;
	$line =~ s/\s*(\%.*)?\n?$//;
	next if $line =~ m/^\s*$/;
	if ($line =~ m/^\\begin\{(code|haskell)\}/) {
		$in_code = 1;	
	}
	elsif ($line =~ m/^\\end\{(code|haskell)\}/) {
		$in_code = 0;
	}
	elsif ($line !~ m/^\\/) {
		if ($in_code) {
			++$code_count unless $line =~ m/--+$/;
			++$real_code_count;
		}
		else {
			my @words = split /\s+/, $line;
			$word_count += scalar(@words);
		}
	}
}

print "Words:                    $word_count\n";
print "Lines of code:            $real_code_count\n";
print "Lines of displayed code:  $code_count\n";
exit 0;
